On This Page

{#jumplink-list}  
[Markdown](/docs/vas/en-us/reporting/developer/all/rest/reporting.md)

Recent Revisions to This Document {#reporting-changes}
======================================================

24.04
-----

This revision contains only editorial changes and no technical updates.

24.03
-----

:
Removed references to deprecated guide.
:
Added new report fields for `Token Management Service`. See [Token Fields](/docs/vas/en-us/reporting/developer/all/rest/reporting/reporting_fields/token.md "").

24.02
-----

:
This revision contains only editorial changes and no technical updates.

24.01
-----

Network Token Life-Cycle Management
:
Added Network Token Life-Cycle Management fields. See [Network Token Life-Cycle Management Fields](/docs/vas/en-us/reporting/developer/all/rest/reporting/reporting_fields/lcm-net-tkn-api-fields.md "").

Time Zones
:
Added Supported Time Zones. See [Supported Time Zones](/docs/vas/en-us/reporting/developer/all/rest/reporting/time-zones.md "").

23.01
-----

:
This revision contains only editorial changes and no technical updates.

VISA Platform Connect: Specifications and Conditions for Resellers/Partners {#vpc-partner-reseller-disclaimer}
==============================================================================================================

The following are specifications and conditions that apply to a Reseller/Partner enabling its merchants through Visa Acceptance platform. Failure to meet any of the specifications and conditions below is subject to the liability provisions and indemnification obligations under Reseller/Partner's contract with Visa/Cybersource.

1. Before boarding merchants for payment processing on a VPC acquirer's connection, Reseller/Partner and the VPC acquirer must have a contract or other legal agreement that permits Reseller/Partner to enable its merchants to process payments with the acquirer through the dedicated VPC connection and/or traditional connection with such VPC acquirer.
2. Reseller/Partner is responsible for boarding and enabling its merchants in accordance with the terms of the contract or other legal agreement with the relevant VPC acquirer.
3. Reseller/Partner acknowledges and agrees that all considerations and fees associated with chargebacks, interchange downgrades, settlement issues, funding delays, and other processing related activities are strictly between Reseller and the relevant VPC acquirer.
4. Reseller/Partner acknowledges and agrees that the relevant VPC acquirer is responsible for payment processing issues, including but not limited to, transaction declines by network/issuer, decline rates, and interchange qualification, as may be agreed to or outlined in the contract or other legal agreement between Reseller/Partner and such VPC acquirer.

DISCLAIMER: NEITHER VISA NOR CYBERSOURCE WILL BE RESPONSIBLE OR LIABLE FOR ANY ERRORS OR OMISSIONS BY THE VISA PLATFORM CONNECT ACQUIRER IN PROCESSING TRANSACTIONS. NEITHER VISA NOR CYBERSOURCE WILL BE RESPONSIBLE OR LIABLE FOR RESELLER/PARTNER BOARDING MERCHANTS OR ENABLING MERCHANT PROCESSING IN VIOLATION OF THE TERMS AND CONDITIONS IMPOSED BY THE RELEVANT VISA PLATFORM CONNECT ACQUIRER.

Reporting API {#reporting_api}
==============================

Using the Reporting API, you can:

* View report attributes before creating a subscription
* View report subscriptions
* Create, edit, and delete report subscriptions
* Download reports
* Create one-time reports

Creating Requests With a Client Application {#reporting-client-apps-create-request}
===================================================================================

The client uses GET, POST, and PUT methods to send requests to the server. To send the request, you must include an authorization token in the header and specify the format for the report that you want to download.

Request Format
--------------

To create a request, you must send an HTTP message to the report server with your client application. The URL and method that you specify in your message indicates which function you are requesting and the parameters of the request. Partners can specify the organization ID, which enables them to create requests that return data for a specific merchant. For example, to download a report, you would format the URL as follows:

```
https://&lt;url_prefix&gt;/reporting/v3/report-downloads?organizationId={organizationId}&download=true&reportDate={date}&reportName={reportName}
```

If the organizationId field value is `SampleMerchant`, you would use the following URL to download the report from February 20, 2018, titled SampleDailyReport from the production system:

```
https://&lt;url_prefix&gt;/reporting/v3/report-downloads?organizationId=SampleMerchant&reportDate=20180220&reportName=SampleDailyReport
```

> IMPORTANT
> Pass the organizationId field in the request only if you are a partner creating a request to retrieve data for a specific merchant. Otherwise, the organizationId field is passed in your authentication method and not required in the request.

Client Application Requirements
-------------------------------

To connect to the report server, your client application must support HTTPS encrypted by using Transport Layer Security (TLS). Your client application must support HTTP/1.1 and TLS 1.2 connections.  
HTTPS libraries are available for many programming languages, including Java, C/C++, Perl, and Visual Basic. You can implement a client in any language that allows you to use HTTPS to communicate with the report server.

> IMPORTANT Although you may be able to use a third-party client application to download the reports, we do not recommend or support third-party client applications or client libraries that may interfere with our applications.

Request Header
--------------

The default format for responses is JSON, but some reports can also return CSV or XML. You can set the response to return CSV or XML in the request header by setting the `Accept` value to either `application/xml` or `text/csv`. The report format can be set for the following reports:

* Conversion Detail
* Purchase and Refund Detail

Viewing Report Definitions {#reporting-definitions-view}
========================================================

You can view a list of supported reports and their attributes before subscribing to them. You can also view the attributes of an individual report type.  
For a summary of all reports, the request format is:

```
GET https://&lt;url_prefix&gt;/reporting/v3/report-definitions?organizationId={organizationId}
```

| Value                   | Description                                                                                                                                                    | Required/ Optional |
|:------------------------|:---------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------|
| \&lt; `url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Production**: api.visaacceptance.com * **Test**: apitest.visaacceptance.com | Required           |
| `{organizationId}`      | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                             | Optional           |
[Summary Report Definition URL Values]

For a summary of a single report type, the request format is:

```keyword varname
GET https://&lt;url_prefix&gt;/reporting/v3/report-definitions/{reportDefinitionName}?organizationId={organizationId}&download=true
```

| Value                    | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    | Required/ Optional |
|:-------------------------|:-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------|
| `&lt; url_prefix&gt;`    | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` {#reporting-definitions-view_ul_u1j_gxk_byb}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                | Required           |
| `{reportDefinitionName}` | Name of the report type you want to review. The options are: * `TransactionRequestClass`: Transaction Request Report * `PaymentBatchDetailClass`: Payment Batch Detail Report * `ExceptionDetailClass`: Transaction Exception Detail Report * `ProcessorSettlementDetailClass`: Processor Settlement Detail Report * `ProcessorEventsDetailClass`: Processor Events Detail Report * `FundingDetailClass`: Funding Detail Report * `AgingDetailClass`: Aging Detail Report * `ChargebackAndRetrievalDetailClass`: Chargeback And Retrieval Detail Report * `DepositDetailClass`: Deposit Detail Report * `FeeDetailClass`: Fee Detail Report * `InvoiceSummaryClass`: Invoice Summary Report * `PayerAuthDetailClass`: Payer Authentication Detail Report * `ConversionDetailClass`: Conversion Detail Report * `SubscriptionDetailClass`: Subscription Detail Report * `ServiceFeeDetailClass`: Service Fee Detail Report * `GatewayTransactionRequestClass`: Gateway Transaction Request Report * `DecisionManagerEventDetailClass`: `Decision Manager` Event Detail Report * `RecurringBillingDetailClass`: Recurring Billing Details Report | Required           |
| `{organizationId}`       | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             | Optional           |
[Single Report Definition URL Values]

{#reporting-definitions-view_table1}

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 404: Report not found.

Managing Report Subscriptions {#reporting-subscriptions-manage}
===============================================================

The API enables you to view the details of a single report subscription and a list of all report subscriptions. You can also create, edit, and delete report subscriptions.

Viewing Report Subscriptions {#reporting-subscriptions-view}
============================================================

For a summary of all report subscriptions, the request format is:

```keyword varname
GET https://&lt;url_prefix&gt;/reporting/v3/report-subscriptions
```

| Value                  | Description                                                                                                                                                        |
|:-----------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| \&lt;`url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` |
[Summary Report Subscriptions URL Values]

For a summary of a single report subscription, the request format is:

```keyword varname
GET https://&lt;url_prefix&gt;/reporting/v3/report-subscriptions/{reportName}
```

| Value                  | Description                                                                                                                                                        | Required/ Optional |
|:-----------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------|
| \&lt;`url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` | Required           |
| `{reportName}`         | Unique name of the report subscription you want to review.                                                                                                         | Required           |
[Single Report Subscription URL Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 404: Report not found.

Creating and Updating Report Subscriptions {#reporting-subscriptions-create-update}
===================================================================================

To create or update a report subscription, your client application must send an HTTP PUT request to the report server. The request body contains the details for creating the subscription, such as the report type, the start time, and the frequency. The format of the URL is as follows:

```keyword varname
PUT https://&lt;url_prefix&gt;/reporting/v3/report-subscriptions
```

For example, if you wanted to create a report titled Daily Transactions, the request would be:

```
PUT https://&lt;url_prefix&gt;/reporting/v3/report-subscriptions
```

The request body would be:

```
{
                "organizationId": "myorg",
                "reportName": "DailyTransactions",
                "reportDefinitionName": "TransactionDetailClass",
                "reportFields": [
                    "Request.RequestID",
                    "Request.TransactionDate",
                    "Request.MerchantID",
                    "BillTo.FirstName",
                    "BillTo.LastName",
                    "BillTo.City",],
                "startTime": "1100",
                "reportMimeType": "application/xml,
                "reportFrequency": "DAILY",
                "timezone": "GMT",
                "startTime": "0900",
                "startDay": "1"
                }
            
```

| Value                | Description                                                                                                                                                        |
|:---------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| `&lt;url_prefix&gt;` | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` |
[Create/Update Report Subscription URL Values]

{#reporting-subscriptions-create-update_table3}  
Not all configuration options below are available for all reports.

| Value                                       | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    | Required/ Optional |
|:--------------------------------------------|:-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------|
| **`organizationId`**                        | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             | Optional           |
| **`reportDefinitionName`**                  | Name of the report type you want to review. The options are: * `TransactionRequestClass`: Transaction Request Report * `PaymentBatchDetailClass`: Payment Batch Detail Report * `ExceptionDetailClass`: Transaction Exception Detail Report * `ProcessorSettlementDetailClass`: Processor Settlement Detail Report * `ProcessorEventsDetailClass`: Processor Events Detail Report * `FundingDetailClass`: Funding Detail Report * `AgingDetailClass`: Aging Detail Report * `ChargebackAndRetrievalDetailClass`: Chargeback And Retrieval Detail Report * `DepositDetailClass`: Deposit Detail Report * `FeeDetailClass`: Fee Detail Report * `InvoiceSummaryClass`: Invoice Summary Report * `PayerAuthDetailClass`: Payer Authentication Detail Report * `ConversionDetailClass`: Conversion Detail Report * `SubscriptionDetailClass`: Subscription Detail Report * `ServiceFeeDetailClass`: Service Fee Detail Report * `GatewayTransactionRequestClass`: Gateway Transaction Request Report * `DecisionManagerEventDetailClass`: `Decision Manager` Event Detail Report * `RecurringBillingDetailClass`: Recurring Billing Details Report | Required           |
| **`reportFields`**                          | Array of field names which should be included in the report. For a list of available fields, see [Reporting Fields and Descriptions](/docs/vas/en-us/reporting/developer/all/rest/reporting/reporting_fields.md "")                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          | Required           |
| **`reportMimeType`**                        | Format of the report. Valid values are: * application/xml * text/csv                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           | Optional           |
| **`reportFrequency`**                       | Frequency of the report subscription. The options are: * Daily * Weekly * Monthly                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              | Optional           |
| **`reportName`**                            | Unique name of the report subscription you want to create or edit.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             | Required           |
| **`timeZone`**                              | Merchant's time zone. For a list of supported time zones, see [Supported Time Zones](/docs/vas/en-us/reporting/developer/all/rest/reporting/time-zones.md ""). For example: America/Chicago                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  | Required           |
| **`startTime`**                             | Time of day the report will run. Format: HHMM                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  | Optional           |
| **`startDay`**                              | Day of month (1-31) the report will run for monthly reports.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   | Optional           |
| **`reportFilters`**                         | Array that contains additional filters.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        | Optional           |
| **`reportPreferences.signedAmounts`**       | Indicator that determines whether or not a negative sign is used for the amount of all refunded transactions. Valid values: * true * false                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     | Optional           |
| **`reportPreferences.fieldNameConvention`** | Specify the field naming convention to be followed in reports (applicable only to csv report formats). Valid values: * Simple Order API * SCMP                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 | Optional           |
| **`selectedMerchantGroupName`**             | Name of the merchant group.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    | Optional           |
[Create/Update Report Subscription Request Body Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 304: Not modified.
* 404: Report not found.

Deleting Report Subscriptions {#reporting-subscriptions-delete}
===============================================================

To delete a report subscription, your client application must send an HTTP DELETE request to the report server. The format of the URL is as follows:

```keyword varname
DELETE https://&lt;url_prefix&gt;/reporting/v3/report-subscriptions/{reportName}
```

For example, if you wanted to delete a report titled Daily Transactions, the request would be:

```keyword varname
DELETE https://&lt;url_prefix&gt;/reporting/v3/report-subscriptions/DailyTransactions
```

| Value                  | Description                                                                                                                                                        | Required/Optional |
|:-----------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|:------------------|
| \&lt;`url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` | Required          |
| `{reportName}`         | Unique name of the report subscription you want to create or edit.                                                                                                 | Required          |
[Delete Report Subscription URL Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 404: Report not found.

Retrieving Available Reports {#reporting-retrieving}
====================================================

Using the API, you can retrieve a list of reports that are generated and available for download. The request format is:

```
https://&lt;url_prefix&gt;/reporting/v3/reports?startTime={startTime}&endTime={endTime}?timeQueryType={timeQueryType}
```

| Value                  | Description                                                                                                                                                        | Required/Optional |
|:-----------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|:------------------|
| \&lt;`url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` | Required          |
| `{organizationId}`     | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                 | Optional          |
| `{startTime}`          | Report start date to search on in ISO 8601 format. **Example**: 2016-11-22T12:00:00.000Z                                                                           | Required          |
| `{endTime}`            | Report end date to search on in ISO 8601 format. **Example**: 2016-11-22T12:00:00.000Z                                                                             | Required          |
| `{timeQueryType}`      | Time you would like to search. Valid values: * reportTimeFrame * executedTime                                                                                      | Required          |
| `{reportMimeType}`     | Format of the report. Valid values are: * application/xml * text/csv                                                                                               | Optional          |
| `{reportFrequency}`    | Frequency of the report subscription. The options are: * Daily * Weekly * Monthly * Adhoc                                                                          | Optional          |
| `{reportName}`         | Unique name of the report.                                                                                                                                         | Optional          |
| `{reportDefinitionId}` | Report definition ID.                                                                                                                                              | Optional          |
| `{reportStatus}`       | Status of the report. The options are: * COMPLETED * PENDING * QUEUED * RUNNING * ERROR * NO_DATA                                                                  | Optional          |
[Create/Update Report Subscription Request URL Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 404: Report not found or there are no available transactions.

Downloading Reports {#reporting-download}
=========================================

You can use the Reporting API to download completed reports. For information about creating reports, see the *`Business Center` Reporting User Guide*. You cannot receive a report in more than one format.

Request Format
--------------

To request a report, your client application must send an HTTP GET message to the report server. The URL that you specify in your message indicates which report you want to download. Format the URL as follows:

```keyword varname
https://&lt;url_prefix&gt;/reporting/v3/report-downloads&organizationId={organizationId}&reportDate={date}&reportName={reportName}
```

For example, if your organization ID were `SampleMerchant`, you would use the following URL to download the XML version of the February 20, 2017, which is named Sample Daily Report:

```keyword varname
https://&lt;url_prefix&gt;/reporting/v3/report-downloads&organizationId=SampleMerchant&reportDate=20170220&reportName=SampleDailyReport
```

| Value                  | Description                                                                                                                                                        | Required/ Optional |
|:-----------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------|
| \&lt;`url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` | Required           |
| `{organizationId}`     | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                 | Optional           |
| `{reportName}`         | Unique name of the report subscription you want to create or edit.                                                                                                 | Required           |
| `{reportDate}`         | The date of the report. For reports that span multiple days, this value would be the end date of the report. **Format:** YYYY-MM-DD                                | Required           |
[Report Download URL Values]

{#reporting-download_table1}  
You can also download reports based on the report ID. To find out the report ID for a report, perform a report search as described in [Retrieving Available Reports](/docs/vas/en-us/reporting/developer/all/rest/reporting/reporting_api/reporting-retrieving.md "") and find the report ID value you want to search for in the response. Format the URL as follows:

```keyword varname
https://&lt;url_prefix&gt;/reporting/v3/reports/{reportId}&organizationId={organizationId}
```

| Value                  | Description                                                                                                                                                        |
|:-----------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| \&lt;`url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` |
| `{reportId}`           | Report ID.                                                                                                                                                         |
| `{organizationId}`     | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                 |
[Report Download by Report ID URL Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 404: Report not found or there are no available transactions.

Creating a One-Time Report {#reporting-onetime-create}
======================================================

To create a one-time report, your client application must send an HTTP POST request to the report server. The request body contains the details for creating the report, such as the report type, the start time, and the frequency. The format of the URL is as follows:

```keyword varname
PUT https://&lt;url_prefix&gt;/reporting/v3/reports
```

The request body would be:

```
{
                "organizationId": "myorg",
                "reportName": "DailyTransactions",
                "reportDefinitionName": "TransactionDetailClass",
                "reportFields": [
                    "Request.RequestID",
                    "Request.TransactionDate",
                    "Request.MerchantID",
                    "BillTo.FirstName",
                    "BillTo.LastName",
                    "BillTo.City",],
                "startTime": "1100",
                "reportMimeType": "application/xml,
                "reportFrequency": "DAILY",
                "timezone": "GMT",
                "startTime": "0900",
                "startDay": "1"
                }
            
```

| Value                  | Description                                                                                                                                                        |
|:-----------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| \&lt;`url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` |
[Create One-Time Report URL Values]

| Value                                        | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    | Required/ Optional |
|:---------------------------------------------|:-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------|
| **`organizationId`**                         | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             | Optional           |
| **`reportDefinitionName`**                   | Name of the report type you want to review. The options are: * `TransactionRequestClass`: Transaction Request Report * `PaymentBatchDetailClass`: Payment Batch Detail Report * `ExceptionDetailClass`: Transaction Exception Detail Report * `ProcessorSettlementDetailClass`: Processor Settlement Detail Report * `ProcessorEventsDetailClass`: Processor Events Detail Report * `FundingDetailClass`: Funding Detail Report * `AgingDetailClass`: Aging Detail Report * `ChargebackAndRetrievalDetailClass`: Chargeback And Retrieval Detail Report * `DepositDetailClass`: Deposit Detail Report * `FeeDetailClass`: Fee Detail Report * `InvoiceSummaryClass`: Invoice Summary Report * `PayerAuthDetailClass`: Payer Authentication Detail Report * `ConversionDetailClass`: Conversion Detail Report * `SubscriptionDetailClass`: Subscription Detail Report * `ServiceFeeDetailClass`: Service Fee Detail Report * `GatewayTransactionRequestClass`: Gateway Transaction Request Report * `DecisionManagerEventDetailClass`: `Decision Manager` Event Detail Report * `RecurringBillingDetailClass`: Recurring Billing Details Report | Required           |
| **`reportFields`**                           | Array of field names which should be included in the report. For a list of available fields, see [Reporting Fields and Descriptions](/docs/vas/en-us/reporting/developer/all/rest/reporting/reporting_fields.md "")                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          | Required           |
| **`reportMimeType`**                         | Format of the report. Valid values are: * application/xml * text/csv                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           | Optional           |
| **`reportName`**                             | Unique name of the report subscription you want to create or edit.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             | Required           |
| **`timeZone`**                               | Merchant's time zone. For a list of supported time zones, see [Supported Time Zones](/docs/vas/en-us/reporting/developer/all/rest/reporting/time-zones.md ""). **Example:** America/Chicago                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  | Optional           |
| **`startTime`**                              | Time of day the report will run. **Format:** HHMM                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              | Optional           |
| **`startDay`**                               | Day of month (1-31) the report will run for monthly reports.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   | Optional           |
| **`reportFilters`**                          | Array that contains additional filters.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        | Optional           |
| **`reportPreferences.signed Amounts`**       | Indicator that determines whether or not a negative sign is used for the amount of all refunded transactions. Valid values: * true * false                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     | Optional           |
| **`reportPreferences.fieldName Convention`** | Specify the field naming convention to be followed in reports (applicable only to csv report formats). Valid values: * SOAPI * SCMP                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            | Optional           |
| **`selectedMerchantGroupName`**              | Name of the merchant group.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    | Optional           |
[Create/Update Report Subscription Request Body Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 304: Not modified.
* 404: Report not found or no transactions are available.

Downloading On-Demand Conversion Detail Report {#reporting-ondemand-detail-download}
====================================================================================

The Conversion Detail Report contains details of transactions for a merchant. To request the report, your client application must send an HTTP GET message to the report server. The default format for responses is JSON, but some reports can also return CSV or XML. You can set the response to return CSV or XML in the request header by setting the `Accept` value to either `application/xml` or `text/csv`.  
Format the URL as follows:

```keyword varname
https://&lt;url_prefix&gt;/reporting/v3/conversion-details?startTime={startTime}&endTime={endTime}&organizationId={organizationId}
```

| Value                   | Description                                                                                                                                                        | Required/ Optional |
|:------------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------|
| \&lt; `url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` | Required           |
| `{startTime}`           | Report start date to search on in ISO 8601 format. **Example:** 2016-11-22T12:00:00.000Z                                                                           | Required           |
| `{endTime}`             | Report end date to search on in ISO 8601 format. **Example:** 2016-11-22T12:00:00.000Z                                                                             | Required           |
| `{organizationId}`      | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                 | Optional           |
[On-Demand Conversion Detail Report URL Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 404: Report not found or no transactions are available.

Downloading On-Demand Notification of Change Report {#reporting-ondemand-noc-download}
======================================================================================

The Notification of Change Report contains a list of `eCheck`-related values updated as a result of a response to an `eCheck` settlement transaction. To request the report, your client application must send an HTTP GET message to the report server. Format the URL as follows:

```keyword varname
https://&lt;url_prefix&gt;/reporting/v3/notification-of-changes?startTime={startTime}&endTime={endTime}
```

| Value                   | Description                                                                                                                                                        | Required/Optional |
|:------------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|:------------------|
| \&lt; `url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` | Required          |
| `{startTime}`           | Report start date to search on in ISO 8601 format. **Example:** 2016-11-22T12:00:00.000Z                                                                           | Required          |
| `{endTime}`             | Report end date to search on in ISO 8601 format. **Example:** 2016-11-22T12:00:00.000Z                                                                             | Required          |
[On-Demand Notification of Change Report URL Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 401: Unauthorized. The provided token is no longer valid.
* 404: Report not found or no transactions are available.
* 500: Internal server error.

Downloading On-Demand Purchase and Refund Detail Report {#reporting-ondemand-purchase-refund-download}
======================================================================================================

The Purchase and Refund Detail Report contains purchase and refund details that have been submitted to your payment processor. Merchants using certain payment processors will also see fee and funding data. To request the report, your client application must send an HTTP GET message to the report server. The default format for responses is JSON, but some reports can also return CSV or XML. You can set the response to return CSV or XML in the request header by setting the `Accept` value to either `application/xml` or `text/csv`.  
Format the URL as follows:

```keyword varname
https://&lt;url_prefix&gt;/reporting/v3/purchase-refund-details&startTime={startTime}&endTime={endTime}
```

| Value                   | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        | Required/ Optional |
|:------------------------|:-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------|
| \&lt; `url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com`                                                                                                                                                                                                                                                                                                                                                                 | Required           |
| `{startTime}`           | Report start date to search on in ISO 8601 format. **Example:** 2016-11-22T12:00:00.000Z                                                                                                                                                                                                                                                                                                                                                                                                                                           | Required           |
| `{endTime}`             | Report end date to search on in ISO 8601 format. **Example:** 2016-11-22T12:00:00.000Z                                                                                                                                                                                                                                                                                                                                                                                                                                             | Required           |
| `{organizationId}`      | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                                                                                                                                                                                                                                                                                                                                                                                 | Optional           |
| `{paymentSubtype}`      | Payment subtypes. The default value is `ALL`. Valid values: * ALL: All Payment Subtypes * VI: Visa * MC: Mastercard * AX: American Express * DI: Discover * DP: PINless Debit                                                                                                                                                                                                                                                                                                                                                      | Optional           |
| `{viewBy}`              | View results by request date or submission date. The default value is `requestDate`. Valid values: * requestDate: Request Date * submissionDate: Submission Date                                                                                                                                                                                                                                                                                                                                                                   | Optional           |
| `{groupName}`           | Group name, which is defined in the Group Management Module in the `Business Center`.                                                                                                                                                                                                                                                                                                                                                                                                                                              | Optional           |
| `{offset}`              | Controls the starting point within the collection of results, which defaults to 0. The first item in the collection is retrieved by setting a zero offset. For example, if you have a collection of 15 items to be retrieved from a resource and you specify limit=5, you can retrieve the entire set of results in 3 successive requests by varying the offset value: `offset=0`, `offset=5`, and `offset=10`. If an offset larger than the number of results is provided, this will result in no embedded object being returned. | Optional           |
| `{limit}`               | Controls the maximum number of items that may be returned for a single request. The default is 2000.                                                                                                                                                                                                                                                                                                                                                                                                                               | Optional           |
[On-Demand Purchase and Refund Detail Report URL Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 401: Unauthorized. The provided token is no longer valid.
* 404: Report not found or no transactions are available.
* 500: Internal server error.

Downloading On-Demand Net Funding Report {#reporting-ondemand-net-funding-download}
===================================================================================

The Net Funding report contains the daily interchange, discount, and standard assessments. Some month-end fees, such as authorizations, are detected at the end of the month and appear in the Net Funding report on that particular day. Total Net Funding is obtained after subtracting chargebacks, fees, and any other negative amounts. To request the report, your client application must send an HTTP GET message to the report server. Format the URL as follows:

```keyword varname
https://&lt;url_prefix&gt;/reporting/v3/net-fundings&startTime={startTime}&endTime={endTime}
```

| Value                   | Description                                                                                                                                                        | Required/ Optional |
|:------------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------|
| \&lt; `url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com` | Required           |
| `{startTime}`           | Report start date to search on in ISO 8601 format. **Example:** 2016-11-22T12:00:00.000Z                                                                           | Required           |
| `{endTime}`             | Report end date to search on in ISO 8601 format. **Example:** 2016-11-22T12:00:00.000Z                                                                             | Required           |
| `{organizationId}`      | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                 | Optional           |
| `{groupName}`           | Group name, which is defined in the Group Management Module in the `Business Center`.                                                                              | Optional           |
[On-Demand Net Funding Report URL Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 401: Unauthorized. The provided token is no longer valid.
* 404: Report not found or no transactions are available.
* 500: Internal server error.

Downloading Payment Batch Summary Report {#reporting-payment-batch-summary-download}
====================================================================================

The Payment Batch Summary report shows total sales and refunds by currency and payment method. To request the report, your client application must send an HTTP GET message to the report server. Format the URL as follows:

```keyword varname
https://&lt;url_prefix&gt;/reporting/v3/payment-batch-summaries&startTime={startTime}&endTime={endTime}
```

| Value                   | Description                                                                                                                                                                                                                                                                                                                                                | Required/ Optional                                                   |
|:------------------------|:-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|:---------------------------------------------------------------------|
| \&lt; `url_prefix`\&gt; | Name of the server from which to download the report. Use one of these values: * **Test:** `apitest.visaacceptance.com` * **Production:** `api.visaacceptance.com`                                                                                                                                                                                         | Required                                                             |
| `{startTime}`           | Report start date to search on in ISO 8601 format (yyyy-MM-dd'T'HH:mm:ss.SSSZ). **Example:** 2019-05-01T12:00:00-05:00                                                                                                                                                                                                                                     | Required                                                             |
| `{endTime}`             | Report end date to search on in ISO 8601 format (yyyy-MM-dd'T'HH:mm:ss.SSSZ). **Example:** 2019-08-30T12:00:00-05:00                                                                                                                                                                                                                                       | Required                                                             |
| `{organizationId}`      | The organization ID under which the report is subscribed. This can be the merchant ID, account ID, or reseller ID.                                                                                                                                                                                                                                         | Optional                                                             |
| `{rollUp}`              | Specifies whether to present data in spans of a single day, week, or month. The options are: * `day` * `week` * `month`                                                                                                                                                                                                                                    | Conditional. Required when requesting breakdown data for a merchant. |
| `{breakdown}`           | Used to request data at the parent-level account, such as Reseller. The options are: * `account_rollup`: Returns batch summaries data aggregated at the account level. * `all_merchant`: Returns batch summaries data for all MIDs that belong to the requesting parent ID. * `selected_merchant`: Returns batch summaries data for the selected merchant. | Conditional. Required when requesting breakdown data for a merchant. |
| `{startDayOfWeek}`      | Start day of week to breakdown data. The options are: * `1` * `2` * `3` * `4` * `5` * `6` * `7`                                                                                                                                                                                                                                                            | Optional                                                             |
[On-Demand Net Funding Report URL Values]

Responses
---------

This call can return one of the following HTTP status codes:

* 200: Ok.
* 400: Invalid request.
* 404: Report not found or no transactions are available.

Reporting Fields and Descriptions {#reporting-fields}
=====================================================

This section contains a list of available reporting fields by field type (for example, billing, settlement, tokens). Where available, additional details, including description, field format, and mapped values, are included.

Application Fields {#application}
=================================

| Field Name |                             Description                              |
|------------|----------------------------------------------------------------------|
| Name       | Name of application used.                                            |
| Rcode      | One-digit code indicating whether the entire request was successful. |
| ReasonCode | Numeric value that corresponds to the result of the overall request. |
| Rflag      | One-word description of the result of the entire request.            |
| Rmsg       | Message that explains the `&lt;ics_flag&gt;` value.                  |
[Application Field Names and Descriptions]

Authorization Results Fields {#auth-results}
============================================

| Field Name |                    Description                     |
|------------|----------------------------------------------------|
| AVSResult  | Optional results of address verification test.     |
| CVVResult  | Optional results of card verification number test. |
[Authorization Results Field Names and Descriptions]

Bank Information Fields {#bank-info}
====================================

Field names in this group are prepended with the text BankInfo:

| Field Name |                                           Description                                            |
|------------|--------------------------------------------------------------------------------------------------|
| Address    | Bank's address.                                                                                  |
| BranchCode | Code that identifies the branch of the customer's bank when you are not using the IBAN.          |
| City       | City in which the bank is located.                                                               |
| Country    | Country in which the bank is located.                                                            |
| Name       | Bank's name.                                                                                     |
| SwiftCode  | Bank's SWIFT code. Unique address of the bank. Also known as the Bank Identification Code (BIC). |
[Bank Information Field Names and Descriptions]

Batch Fields {#batch}
=====================

| Field Name  |                       Description                       |
|-------------|---------------------------------------------------------|
| BatchDate   | Date when the batch was sent to the processor.          |
| BatchID     | Batch in which the transaction was sent.                |
| Status      | Status of batch file.                                   |
| SuccessFlag | Indicates whether batch file processing was successful. |
[Batch Field Names and Descriptions]

Bill To Fields {#bill-to}
=========================

Field names in this group are prepended with the text BillTo:

| Field Name   | Description                                                                                                                                                                                                                      |
|:-------------|:---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| Address1     | First line of the billing street address as it appears on the credit card issuer's records.                                                                                                                                      |
| Address2     | Additional address information.                                                                                                                                                                                                  |
| City         | City of the billing address.                                                                                                                                                                                                     |
| CompanyName  | Name of the customer's company.                                                                                                                                                                                                  |
| CompanyTaxID | Tax identification number of customer's company.                                                                                                                                                                                 |
| Country      | Country of the billing address.                                                                                                                                                                                                  |
| CustomerID   | Your identifier for the customer.                                                                                                                                                                                                |
| Email        | Customer's email address, including the full domain name.                                                                                                                                                                        |
| FirstName    | First name of the billed customer.                                                                                                                                                                                               |
| HostName     | DNS resolved hostname from billTo_ipAddress.                                                                                                                                                                                     |
| IPAddress    | Customer's IP address.                                                                                                                                                                                                           |
| LastName     | Last name of the billed customer.                                                                                                                                                                                                |
| MiddleName   | Middle name of the billed customer.                                                                                                                                                                                              |
| NameSuffix   | Suffix of billed customer.                                                                                                                                                                                                       |
| PersonalID   | Personal identifier. This field is supported only for Redecard in Brazil for `Cybersource Latin American Processing`. Set this field to the Cadastro de Pessoas Fisicas (CPF), which is required for AVS for Redecard in Brazil. |
| Phone        | Customer's phone number.                                                                                                                                                                                                         |
| State        | State or province of the billing address.                                                                                                                                                                                        |
| Title        | Title of the billed customer.                                                                                                                                                                                                    |
| UserName     | Customer's user name.                                                                                                                                                                                                            |
| Zip          | ZIP/Postal code for the billing address. The postal code must consist of five to nine digits.                                                                                                                                    |
[Bill To Field Names and Descriptions]

Chargeback and Retrieval Fields {#chargeback}
=============================================

|           Field Name            |                                                           Description                                                            |
|---------------------------------|----------------------------------------------------------------------------------------------------------------------------------|
| AdjustmentAmount                | Amount of the chargeback adjustment.                                                                                             |
| AdjustmentCurrency              | Currency of the chargeback adjustment.                                                                                           |
| AdjustmentARN                   | Association reference number.                                                                                                    |
| CaseIdentifier                  | Numerical identifier created by `Visa Acceptance Solutions` to represent a unique chargeback, representment, or other exception. |
| CaseNumber                      | Processor-assigned case number.                                                                                                  |
| CaseTime                        | The date that the case was opened.                                                                                               |
| CaseType                        | Description of the case type.                                                                                                    |
| ChargebackAmount                | Amount of the chargeback.                                                                                                        |
| ChargebackCurrency              | Chargeback currency code.                                                                                                        |
| ChargebackMessage               | Text message from the issuer explaining the reason for the chargeback or other exception.                                        |
| ChargebackReasonCode            | Association chargeback reason code.                                                                                              |
| ChargebackReasonCodeDescription | Text description of the reason code.                                                                                             |
| ChargebackTime                  | The date that the chargeback was originated by the issuing bank.                                                                 |
| DocumentIndicator               | Indicates whether or not there are associated documents. Possible values: * `Y` * `N`                                            |
| FeeAmount                       | Amount of the chargeback exception fee.                                                                                          |
| FeeCurrency                     | Currency code for the chargeback exception fee.                                                                                  |
| FinancialImpact                 | Indicates whether or not there is a financial impact. Possible values: * `Y` * `N`                                               |
| FinancialImpactType             | Debit, credit, or none.                                                                                                          |
| MerchantCategoryCode            | Four-digit number that the payment card industry uses to classify merchants into market segments.                                |
| PartialIndicator                | Flag indicating whether the transaction is enabled for partial chargeback.                                                       |
| ResolutionTime                  | Resolution time in UTC.                                                                                                          |
| ResolvedToIndicato              | Indicates resolved to status of transaction. Possible values: * `B`: Bank * `M`: Merchant * `S`: Split * `G`: General ledger     |
| RespondByDate                   | Date by which item must be submitted to the chargeback processor to allow sufficient time for representment.                     |
| TransactionType                 | Capture type of the original transaction.                                                                                        |
[Chargeback and Retrieval Field Names and Descriptions]

Check Fields {#check}
=====================

Field names in this group are prepended with the text Check:

|    Field Name     |                                 Description                                  |
|-------------------|------------------------------------------------------------------------------|
| BankTransitNumber | ---                                                                          |
| AccountEncoderID  | Identifier for the bank that provided the customer's encoded account number. |
| SecCode           | Authorization method used for the transaction.                               |
[Check Field Names and Descriptions]

Conversion Fields {#conversion}
===============================

|    Field Name    |                       Description                        |
|------------------|----------------------------------------------------------|
| ConversionDate   | Date order converted.                                    |
| NewDecision      | Reviewer evaluation result.                              |
| OriginalDecision | Order profile evaluation result.                         |
| Profile          | Order profile used to evaluate the order.                |
| Reviewer         | Person who evaluated order originally marked for review. |
| ReviewerComments | Additional information added by reviewer.                |
| Queue            | Review queue originally assigned to order.               |
[Conversion Field Names and Descriptions]

Deposit Fields {#deposit}
=========================

| Field Name              | Description                                                                                                                     |
|:------------------------|:--------------------------------------------------------------------------------------------------------------------------------|
| Amount                  | Amount of the deposit.                                                                                                          |
| Category                | Category of the deposit.                                                                                                        |
| Currency                | Currency code of the deposit.                                                                                                   |
| ExchangeRate            | Exchange rate. Includes a decimal point and up to 4 decimal places.                                                             |
| ExchangeRateDescription | Exchange rate description from the funding bank.                                                                                |
| Identifier              | Unique reference number for this deposit.                                                                                       |
| MerchantBankAcctLast4   | Bank account number to which the funds transfer will be deposited. For security purposes, all but the last 4 digits are masked. |
| MerchantBankAcctName    | Name used on the bank account.                                                                                                  |
| MerchantBankCode        | Routing number for the account to which the funds transfer will be deposited.                                                   |
| MerchantBankCountry     | Country in which the bank is located. Use the two-character ISO Standard Country Codes.                                         |
| MerchantBankName        | Bank's name.                                                                                                                    |
| MerchantID              | `Visa Acceptance Solutions` merchant ID.                                                                                        |
| Method                  | Funds transfer method.                                                                                                          |
| Status                  | Status of the deposit. Possible values: * `S`: Success * `P`: Pending * `F`: Failed                                             |
| Time                    | Deposit time for the transaction in UTC.                                                                                        |
| TransferMessage         | Deposit transfer message provided by the processor.                                                                             |
| Type                    | Description of events included in this funds transfer.                                                                          |
[Deposit Field Names and Descriptions]

Device Fields {#device}
=======================

[...]
